#ifndef _DECL_GreedyRefLB_H_
#define _DECL_GreedyRefLB_H_
#include "charm++.h"
#include "CentralLB.decl.h"

/* DECLS: group GreedyRefLB: CentralLB{
void GreedyRefLB(void);
};
 */
class GreedyRefLB;
class CProxy_GreedyRefLB:  public virtual _CK_GID, public CProxy_CentralLB{
  public:
    static int __idx;
    static void __register(const char *s, size_t size);
    CProxy_GreedyRefLB(CkGroupID _gid) :CProxy_CentralLB(_gid){ _ck_gid = _gid; _setChare(0); }
    CProxy_GreedyRefLB(CkChareID __cid) :CProxy_CentralLB(__cid){ ckSetChareId(__cid); }
    CkChareID ckGetChareId(void) { return _ck_cid; }
    void ckSetChareId(CkChareID __cid){_CHECK_CID(__cid,__idx);_ck_cid=__cid;_setChare(1);}
    CkGroupID ckGetGroupId(void) { return _ck_gid; }
    void ckSetGroupId(CkGroupID _gid){_ck_gid=_gid;_setChare(0);}
    GreedyRefLB* ckLocalBranch(void) {
      return (GreedyRefLB *) CkLocalBranch(_ck_gid);
    }
    static GreedyRefLB* ckLocalBranch(CkGroupID gID) {
      return (GreedyRefLB *) CkLocalBranch(gID);
    }
/* DECLS: void GreedyRefLB(void);
 */
    static CkGroupID ckNew(void);
    static CkGroupID ckNewSync(void);
    CProxy_GreedyRefLB(int retEP, CkChareID *cid);
    CProxy_GreedyRefLB(void);
    static int  __idx_GreedyRefLB_void;
    static int  ckIdx_GreedyRefLB(void) { return __idx_GreedyRefLB_void; }
    static void _call_GreedyRefLB_void(void* msg, GreedyRefLB* obj);
};

extern void _registerGreedyRefLB(void);
#endif
